--[[
-- Name: TinyTip
-- Author: Thrae of Maelstrom (aka "Matthew Carras")
-- Release Date: 6-25-06
--
-- These functions include the addition of more textures
-- to the tooltip, such as the PvP Rank Icon or buffs and
-- debuffs. If you do not use these options, then you can
-- safely remove this file from the TOC or delete it.
--]]

local ResetPvPIcon, tmp
TinyTipIcons_PvPTexture = nil

local Original_GameTooltip_ShowScript, GameTooltip_ShowScriptIsHooked
local function GameTooltip_ShowScript()
	if Original_GameTooltip_ShowScript then
		Original_GameTooltip_ShowScript()
	end
	if DoResetPvPIcon then
		DoResetPvPIcon = nil
	elseif TinyTipIcons_PvPTexture then
		TinyTipIcons_PvPTexture:Hide()
	end	
end

local Original_GameTooltip_HideScript, GameTooltip_HideScriptIsHooked
local function GameTooltip_HideScript()
	if TinyTipIcons_PvPTexture then
		TinyTipIcons_PvPTexture:Hide()
		DoResetPvPIcon = nil
	end
	if Original_GameTooltip_HideScript then
		Original_GameTooltip_HideScript()
	end
end

function TinyTipIcons_LazyUnhook()
	TinyTipIcons_PvPTexture = nil
end

function TinyTipIcons_AddPvPIconNHook()
	if not TinyTipIcons_PvPTexture then
		TinyTipIcons_PvPTexture = TinyTipUtil_Tooltip:CreateTexture(nil, "ARTWORK")
	end
	TinyTipIcons_PvPTexture:SetPoint("TOPRIGHT", GameTooltip, "TOPLEFT", 0, 0)
	TinyTipIcons_PvPTexture:Hide()
	if not GameTooltip_ShowScriptIsHooked then
		Original_GameTooltip_ShowScript = GameTooltip:GetScript("OnShow")
		GameTooltip:SetScript("OnShow", GameTooltip_ShowScript)
		GameTooltip_ShowScriptIsHooked = true
	end
	if not GameTooltip_HideScriptIsHooked then
		Original_GameTooltip_HideScript = GameTooltip:GetScript("OnHide")
		GameTooltip:SetScript("OnHide", GameTooltip_HideScript)
		GameTooltip_HideScriptIsHooked = true
	end
end

function TinyTipIcons_ResetPvPIcon(rank)
	if rank > 0 then
		TinyTipIcons_PvPTexture:SetTexture( string.format("%s%02d",
											"Interface\\PvPRankBadges\\PvPRank",
											rank))
		DoResetPvPIcon = true
		TinyTipIcons_PvPTexture:Show()
	else
		DoResetPvPIcon = nil
		TinyTipIcons_PvPTexture:Hide()
	end
end
