--[[
-- Name: TinyTip
-- Author: Thrae of Maelstrom (aka "Matthew Carras")
-- Release Date: 6-25-06
--
-- These functions include adding target data. 
-- If you don't use these options, then you can safely 
-- delete this file or remove it from the TOC.
--]]

local tmp,tmp2,i,pid,RaidTable,c
local strformat = string.format

-- Add Target of Mouseover (what they're targeting)
function TinyTipTargets_Mouse(unit)
	if UnitExists("mouseovertarget") then
		if UnitIsUnit("mouseovertarget", "player") then
			GameTooltip:AddLine( strformat("%s: |cFFFFFFFF<<%s>>|r", 
								 TinyTipLocale_Targeting, 
								 TinyTipLocale_YOU) )
		elseif UnitIsPlayer("mouseovertarget") then
			GameTooltip:AddLine( strformat("%s: |cFF%s%s|r", 
								 TinyTipLocale_Targeting, 
								 TinyTipUtil_ColorPlayer("mouseovertarget"), 
								 UnitName("mouseovertarget") or "Unknown" ) )
		else
			GameTooltip:AddLine( strformat("%s: |cFFFFFFFF%s|r", 
								 TinyTipLocale_Targeting, 
								 UnitName("mouseovertarget") or "Unknown" ) )
		end
	end
end

-- Add How Many Raid Members are targeting this unit (except you)
function TinyTipTargets_Raid(unit,num,flag)
		c,tmp2 = 0,nil
		if flag == 2 and RaidTable then
			for c,tmp in RaidTable do
				if tmp then RaidTable[c]["n"] = 0 end
			end
		end
		for i = 1,num,1 do
			pid = "raid" .. i
			if UnitIsUnit(pid .. "target",unit) and not UnitIsUnit(pid,"player") then
				if flag == 2 then
					_,c = UnitClass(pid)
					if c then
						if not RaidTable then RaidTable = {} end
						if not RaidTable[c] then RaidTable[c] = {} end
						if not RaidTable[c]["l"] then RaidTable[c]["l"] = UnitClass(pid) end
						RaidTable[c]["n"] = RaidTable[c]["n"] + 1
					end
				elseif flag == 3 then
					tmp2 = strformat("%s|cFF%s%s|r\n", 
										  tmp2 or "", TinyTipUtil_ColorPlayer(pid), UnitName(pid) or "Unknown")
					c = c + 1
				else
					if not tmp2 then tmp2 = 0 end
					tmp2 = tmp2 + 1
				end
			end
		end
		if flag == 2 and RaidTable then
			GameTooltip:AddLine( TinyTipLocale_TargetedBy .. ":\n" ) 
			for c,tmp in RaidTable do
				if tmp and tmp.n and tmp.n > 0 and tmp.l then
					GameTooltip:AddLine( strformat("|cFF%s%s|r: %d", 
										  string.format("%2x%2x%2x", 
														RAID_CLASS_COLORS[c].r*255, 
														RAID_CLASS_COLORS[c].g*255, 
														RAID_CLASS_COLORS[c].b*255), 
										  tmp.l,
										  tmp.n ) )
				end
			end
		elseif tmp2 and flag == 3 then
			GameTooltip:AddLine( strformat("%s: %s%s", 
								 TinyTipLocale_TargetedBy, 
								 ((c > 1) and "\n") or "",
								tmp2) )
		elseif tmp2 and tmp2 > 0 then
			GameTooltip:AddLine( strformat("%s: (|cFFFFFFFF%s|r) %s", 
											TinyTipLocale_TargetedBy, tostring(tmp2), 
											getglobal("RAID")) )
		end
end

-- Add How Many Party Members are targeting this unit (except you)
function TinyTipTargets_Party(unit, num, flag)
		tmp,tmp2 = 0,nil
		for i = 1,num,1 do
			pid = "party" .. i	
			if UnitIsUnit(pid .. "target",unit) and not UnitIsUnit(pid, "player") then
				if flag ~= 2 then
					tmp2 = strformat("%s|cFF%s%s|r\n", 
										  tmp2 or "", TinyTipUtil_ColorPlayer(pid), UnitName(pid) or "Unknown")
					tmp = tmp + 1
					
				else
					if not tmp2 then tmp2 = 0 end
					tmp2 = tmp2 + 1
				end
			end
		end
		if tmp2 then
			if flag ~= 2 then
				GameTooltip:AddLine( strformat("%s: %s%s", 
									TinyTipLocale_TargetedBy, 
									((tmp > 0) and "\n") or "",
									tmp2) )
			else
				GameTooltip:AddLine( strformat("%s: (|cFFFFFFFF%s|r) %s", 
											 TinyTipLocale_TargetedBy, tmp2, getglobal("TUTORIAL_TITLE19")) )
			end
		end
end
